<template>
    <transition-group name="blur-fade-stagger" tag="view">
        <view v-for="job in dataSource" :key="job.id" :style="{ '--i': 2 }">
            <view v-if="!job.isTitle" class="cards" @click="nextDetail(job)">
                <view class="card-company">
                    <text class="company">{{ job.gwmc }}</text>
                    <view class="salary">
                        <Salary-Expectation
                            :max-salary="job.maxSalary"
                            :min-salary="job.minSalary"
                        ></Salary-Expectation>
                    </view>
                </view>
                <view class="card-companyName">{{ job.gsmc }}</view>
                <view class="card-tags">
                    <view class="tag">
                        {{ job.xlyq == '不限' ? '学历不限' : job.xlyq }}
                    </view>
                    <view class="tag">
                        {{ job.gwgzjy == '不限' ? '经验不限' : job.gwgzjy }}
                    </view>
                    <view class="tag">
                        {{ vacanciesTo(job.zprs) }}
                    </view>
                </view>
                <view class="card-bottom">
                    <view>{{ parseDateTime(job.createTime).date }}</view>
                    <view>
                        <!-- <convert-distance
                        :alat="job.latitude"
                        :along="job.longitude"
                        :blat="latitude"
                        :blong="longitude"
                    ></convert-distance>
                    <dict-Label class="mar_le10" dictType="area" :value="job.jobLocationAreaCode"></dict-Label> -->
                    </view>
                </view>
            </view>
            <view class="date-jobTitle" v-else>
                {{ job.title }}
            </view>
        </view>
    </transition-group>
</template>

<script setup>
import { inject, computed, toRaw, ref, watch } from 'vue';
const { insertSortData, navTo, vacanciesTo } = inject('globalFunction');
import { useRecommedIndexedDBStore } from '@/stores/useRecommedIndexedDBStore.js';
const recommedIndexDb = useRecommedIndexedDBStore();
const dataSource = ref([]);
const props = defineProps({
    list: {
        type: Array,
        default: '标题',
    },
    longitude: {
        type: Number,
        default: 120.382665,
    },
    latitude: {
        type: Number,
        default: 36.066938,
    },
    seeDate: {
        type: String,
        default: '',
    },
});

const listData = computed(() => {
    if (props.seeDate && props.list.length) {
        const ulist = toRaw(props.list);
        const [reslist, lastDate] = insertSortData(ulist, props.seeDate);
        return reslist;
    }
    return props.list;
});

const processedIds = new Set();
watch(
    () => props.list,
    (newList) => {
        if (!Array.isArray(newList)) return;
        const newItems = newList.filter((item) => !processedIds.has(item.id));
        if (newItems.length === 0) return;
        newItems.forEach((item) => processedIds.add(item.id));
        const delay = 50;
        newItems.forEach((item, index) => {
            setTimeout(() => {
                dataSource.value.push(item);
            }, index * delay);
        });
    },
    { immediate: true }
);

function nextDetail(job) {
    // 记录岗位类型，用作数据分析
    if (job.jobCategory) {
        const recordData = recommedIndexDb.JobParameter(job);
        recommedIndexDb.addRecord(recordData);
    }
    navTo(`/packageA/pages/post/post?jobId=${btoa(job.id)}&dataType=2`);
}
function parseDateTime(datetimeStr) {
    if (!datetimeStr) return { time: '', date: '' };

    const dateObj = new Date(datetimeStr);

    if (isNaN(dateObj.getTime())) return { time: '', date: '' }; // 无效时间

    const year = dateObj.getFullYear();
    const month = String(dateObj.getMonth() + 1).padStart(2, '0');
    const day = String(dateObj.getDate()).padStart(2, '0');
    const hours = String(dateObj.getHours()).padStart(2, '0');
    const minutes = String(dateObj.getMinutes()).padStart(2, '0');

    return {
        time: `${hours}:${minutes}`,
        date: `${year}-${month}-${day}`,
    };
}
</script>

<style lang="stylus" scoped>
.date-jobTitle{
    font-weight: 400;
    font-size: 28rpx;
    color: #495265;
    padding: 28rpx 0 0 20rpx
}
.cards{
    padding: 32rpx;
    background: #FFFFFF;
    box-shadow: 0rpx 0rpx 8rpx 0rpx rgba(0,0,0,0.04);
    border-radius: 20rpx 20rpx 20rpx 20rpx;
    margin-top: 22rpx;
    .card-company{
        display: flex
        justify-content: space-between
        align-items: flex-start
        .company{
            font-family: 'PingFangSC-Medium', 'PingFang SC', 'Helvetica Neue', Helvetica, Arial, 'Microsoft YaHei', sans-serif;
            font-weight: 500;
            font-size: 30rpx;
            color: #333333;
        }
        .salary{
            font-family: DIN-Medium;
            font-weight: 500;
            font-size: 26rpx;
            color: #4C6EFB;
            white-space: nowrap
            line-height: 48rpx
        }
    }
    .card-companyName{
        font-weight: 400;
        font-size: 28rpx;
        color: #6C7282;
    }
    .card-tags{
        display: flex
        flex-wrap: wrap
        .tag{
            font-family: 'PingFangSC-Medium', 'PingFang SC', 'Helvetica Neue', Helvetica, Arial, 'Microsoft YaHei', sans-serif;
            width: fit-content;
            height: 30rpx;
            background: #F4F4F4;
            border-radius: 4rpx;
            padding: 6rpx 20rpx;
            line-height: 30rpx;
            font-weight: 400;
            font-size: 24rpx;
            color: #6C7282;
            text-align: center;
            margin-top: 14rpx;
            white-space: nowrap
            margin-right: 20rpx
        }
    }
    .card-bottom{
        margin-top: 32rpx
        display: flex
        justify-content: space-between
        font-size: 28rpx;
        color: #6C7282;
    }
}
</style>
